import { AnyAction } from 'redux';
import { ThunkAction } from 'redux-thunk';
export interface AbortAction {
    type: string;
}
export declare type ActionMutator<A extends FetchStateAction> = (action: A) => AnyAction;
export interface Actions {
    onAbort?: ActionMutator<AbortAction> | Object;
    onReject?: ActionMutator<RejectAction> | Object;
    onRequest?: ActionMutator<RequestAction> | Object;
    onResolve?: ActionMutator<ResolveAction> | Object;
}
interface Conditional {
    (state?: Object): boolean;
}
declare type FetchAction = ThunkAction<Promise<AnyAction>, any, void, AnyAction>;
export interface FetchActionTypes {
    ABORT: string;
    REJECT: string;
    REQUEST: string;
    RESOLVE: string;
}
export interface MakeFetchActions {
    default?: MakeFetchActions;
    (id: string, input: Request | string, init: Init, actions: Actions, abortController?: AbortController | null, conditional?: Conditional): FetchAction;
}
declare type FetchStateAction = AbortAction | RejectAction | RequestAction | ResolveAction;
declare type Init = RequestInit | ((state?: Object) => RequestInit);
export interface RejectAction {
    error: Object | string;
    headers: Object | null;
    statusCode: null | number;
    type: string;
}
export interface RequestAction {
    type: string;
}
export interface ResolveAction {
    body: Object | string;
    headers: Object;
    statusCode: number;
    type: string;
}
export {};
