"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
var FetchError = (function () {
    function FetchError(message, headers, statusCode) {
        this.headers = headers;
        this.message = message;
        this.statusCode = statusCode;
    }
    return FetchError;
}());
var MIN_ERROR_STATUS_CODE = 400;
var MAX_ERROR_STATUS_CODE = 600;
var createAction = function (action, actionMutator) {
    if (!actionMutator) {
        return action;
    }
    if (typeof actionMutator === 'object') {
        return __assign({}, action, actionMutator);
    }
    return actionMutator(action);
};
var makeActionType = function (subtype, id) {
    return id + "_" + subtype;
};
var parseResponse = function (response) {
    return __awaiter(this, void 0, void 0, function () {
        var response2, body, e_1, headers;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    response2 = response.clone();
                    body = '';
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 3, , 5]);
                    return [4, response2.json()];
                case 2:
                    body = _a.sent();
                    return [3, 5];
                case 3:
                    e_1 = _a.sent();
                    return [4, response.text()];
                case 4:
                    body = _a.sent();
                    return [3, 5];
                case 5:
                    headers = {};
                    response.headers.forEach(function (entry) {
                        headers[entry[0]] = entry[1];
                    });
                    return [2, [body, headers, response.status]];
            }
        });
    });
};
var fetchActionTypes = function (id) { return ({
    ABORT: makeActionType('ABORT', id),
    REQUEST: makeActionType('REQUEST', id),
    RESOLVE: makeActionType('RESOLVE', id),
    REJECT: makeActionType('REJECT', id),
}); };
var makeFetchActions = function (id, url, init, actions, abortController, conditional) {
    if (init === void 0) { init = Object.create(null); }
    if (actions === void 0) { actions = Object.create(null); }
    return function (dispatch, getState) {
        return __awaiter(this, void 0, void 0, function () {
            var signal, requestAction, dispatchReject, requestInit, response, caughtError_1, _a, body, headers, statusCode, resolveAction, result;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        if (typeof conditional === 'function' && !conditional(getState())) {
                            return [2, { type: 'ERROR' }];
                        }
                        signal = null;
                        if (typeof AbortController !== 'undefined' && abortController) {
                            signal = abortController.signal;
                            signal.addEventListener('abort', function () {
                                var abortAction = {
                                    type: makeActionType('ABORT', id),
                                };
                                dispatch(createAction(abortAction, actions !== null &&
                                    Object.prototype.hasOwnProperty.call(actions, 'onAbort')
                                    ? actions.onAbort
                                    : null));
                            });
                        }
                        requestAction = {
                            type: makeActionType('REQUEST', id),
                        };
                        dispatch(createAction(requestAction, actions !== null &&
                            Object.prototype.hasOwnProperty.call(actions, 'onRequest')
                            ? actions.onRequest
                            : null));
                        dispatchReject = function (err) {
                            var rejectAction = {
                                error: err.message || 'Script error',
                                headers: err instanceof FetchError ? err.headers : null,
                                statusCode: err instanceof FetchError ? err.statusCode : null,
                                type: makeActionType('REJECT', id),
                            };
                            var result = createAction(rejectAction, actions !== null &&
                                Object.prototype.hasOwnProperty.call(actions, 'onReject')
                                ? actions.onReject
                                : null);
                            dispatch(result);
                            return result;
                        };
                        requestInit = typeof init === 'function'
                            ? init.length
                                ? init(getState())
                                : init()
                            : init;
                        _b.label = 1;
                    case 1:
                        _b.trys.push([1, 3, , 4]);
                        return [4, fetch(url, __assign({ signal: signal }, requestInit))];
                    case 2:
                        response = _b.sent();
                        return [3, 4];
                    case 3:
                        caughtError_1 = _b.sent();
                        return [2, dispatchReject(caughtError_1)];
                    case 4: return [4, parseResponse(response)];
                    case 5:
                        _a = __read.apply(void 0, [_b.sent(), 3]), body = _a[0], headers = _a[1], statusCode = _a[2];
                        if (statusCode >= MIN_ERROR_STATUS_CODE &&
                            statusCode < MAX_ERROR_STATUS_CODE) {
                            return [2, dispatchReject(new FetchError(body, headers, statusCode))];
                        }
                        resolveAction = {
                            body: body,
                            headers: headers,
                            statusCode: statusCode,
                            type: makeActionType('RESOLVE', id),
                        };
                        result = createAction(resolveAction, actions !== null &&
                            Object.prototype.hasOwnProperty.call(actions, 'onResolve')
                            ? actions.onResolve
                            : null);
                        dispatch(result);
                        return [2, result];
                }
            });
        });
    };
};
module.exports = {
    makeFetchActions: makeFetchActions,
    fetchActionTypes: fetchActionTypes,
};
exports.default = makeFetchActions;
